// Преобразование типов

// --------------------------------------------------------------------------------------------------------------
// 1. Чему равно a, почему?
//    let a = 0 || 'string';
//    let a = 1 && 'string';
//    let a = null || 25;
//    let a = null && 25;
//    let a = null || 0 || 35;
//    let a = null && 0 && 35';
// --------------------------------------------------------------------------------------------------------------
let a = 0 || 'string';
console.log(a); // string
// оператор ИЛИ вычисляет ровно столько значений, сколько необходимо - до первого true.
// При этом оператор ИЛИ возвращает то значение, на котором остановились вычисления.
// В данном случае левый аргумент (0) является number и приводится к логическому типу, а 0 - воспринимается как false.
// А не пустая строка - true.

let a = 1 && 'string';
console.log(a); // string
// оператор И вычисляет операнды слева направо до первого "ложного" и возвращает его, а если все истинные – то последнее значение.
// т.к. левый аргумент (1) - true, то оператор И возвращает второй аргумент (string)

let a = null || 25;
console.log(a); // 25
// Boolean(null) = false. Boolean(25) = true.
// Помним про "до первого true".

let a = null && 25;
console.log(a); // null
// Boolean(null) = false. Boolean(25) = true.
// Потому что, левый аргумент - false, оператор И возвращает его и заканчивает вычисления.

let a = null || 0 || 35;
console.log(a); // 35
// Boolean(null) = false. Boolean(0) = false. Boolean(35) = true.
// Помним про "до первого true".

let a = null && 0 && 35;
console.log(a); // null
// Boolean(null) = false. Boolean(0) = false. Boolean(35) = true.
// Помним про "до первого false".

// --------------------------------------------------------------------------------------------------------------
// 2. Что отобразится в консоли. Почему?
//    12 + 14 + '12'
//    3 + 2 - '1'
//    '3' + 2 - 1
//    true + 2
//    +'10' + 1
//    undefined + 2
//    null + 5
//    true + undefined
// --------------------------------------------------------------------------------------------------------------
let _1 = 12 + 14 + '12';
console.log(_1); // 2612
// Сначала будет сложение Number (12+14), а после конкатенация Number + String.

let _2 = 3 + 2 - '1';
console.log(_2); // 4
// Оператор "-" работает только с числами, так что он сразу приводит "1" к 1. Number + Number - Number

let _3 = '3' + 2 - 1;
console.log(_3); // 31
// Сначала будет конкатенация String + Number, а потом Number - Number

let _4 = true + 2;
console.log(_4); // 3
// Boolean + Number. При этом значение true преобразуется в 1.

let _5 = +'10' + 1;
console.log(_5); // 11
// Унарный плюс преобразует строку в число и происходит сложение Number + Number

let _6 = undefined + 2;
console.log(_6); // NaN
// undefined в численном преобразовании всегда NaN. Сложение с NaN выдаст NaN.

let _7 = null + 5;
console.log(_7); // 5
// null в численном преобразовании это 0. Number + Number

let _8 = true + undefined;
console.log(_8); // NaN
// Помним, что при арифметических операциях true и undefined преобразуеют в 1 и NaN соответственно.
// а сложение с NaN - это NaN.
